<template>
  <v-col class="col-m12">
    <v-autocomplete
      v-model="model"
      :items="items"
      :loading="isLoading"
      :search-input.sync="buscarUsuarios"
      hide-no-data
      hide-selected
      dense
      item-text="Description"
      item-value="id"
      :label="labelSearch"
      return-object
      :auto-select-first="selectFirst"
      :disabled="disabled"
    >
      <template v-slot:selection="data">
        <v-chip
          v-bind="data.attrs"
          :input-value="data.selected"
          close
          @click="data.select"
          @click:close="remove()"
        >
          {{ data.item.Description}}
        </v-chip>
      </template>
      <template v-slot:item="data">
        <template>

          <v-list-item-content>
            <v-list-item-title v-html="data.item.Description" class="fw-bold"></v-list-item-title>
            <v-list-item-subtitle v-html="data.item.email"></v-list-item-subtitle>
          </v-list-item-content>
        </template>
      </template>
    </v-autocomplete>
  </v-col>
</template>

<script>
import UsuarioServicio from '@/store/services/UsuarioServicio'
export default {
  name: 'UsuariosBuscador',
  props: {
    searchCount: {
      type: Number,
      default: 2,
    },
    usuarioData: {
      type: Object,
      default: null
    },
    disabled: {
      type: Boolean,
      default: false
    },
    labelSearch: {
      type: String,
      required: true
    },
  },
  data() {
    return {
      isLoading: false,
      entries: [],
      model: null,
      buscarUsuarios: null,
      descriptionLimit: 30,
      selectFirst: false
    };
  },
  methods: {
    remove () {
      this.model = null
    },
    setValues() {
      if (this.usuarioData) {
        this.selectFirst = true
        let name = `${this.usuarioData.name}`
        let description = {"Description": name}
        let mergeData = { ...this.usuarioData, ...description}
        this.entries.push(mergeData)
        this.model = mergeData
      }
    }
  },
  computed: {
    items () {
      return this.entries.map(entry => {
        console.log(entry)
        let fullName = entry.name
        const Description = fullName.length > this.descriptionLimit
          ? fullName.slice(0, this.descriptionLimit) + '...'
          : fullName

        return Object.assign({}, entry, { Description })
      })
    },
  },
  watch: {
    model(newSelected) {
      this.$emit('onSeleccionarUsuario', newSelected);
    },
    async buscarUsuarios(query) {
      if (query !== null && query.length > this.searchCount) {
        this.isLoading = true
        const params = {
          order_by: 'created_at',
          order_direction: 'DESC',
          filter: query,
        }
        try {
          let response = await UsuarioServicio.index(params)
          this.entries = response.data.data;
          this.isLoading = false
        } catch (error) {
          this.isLoading = false;
          if (error.response.status !== 401) {
            console.log(error.response)
          }
        }
      }
    },
    usuarioData: {
      immediate: true,
      handler() {
        this.setValues()
      }
    }
  },
  created() {
    this.setValues()
  }
}
</script>

<style>

</style>
